import { DataTypes, Model } from "sequelize";
import { sequelize } from "../database/database";

export class LpTtnEndDeviceUplinks extends Model {
  public lp_ttn_end_device_uplinks_id!: string;
  public device_id!: string;
  public application_ids!: string;
  public dev_eui!: string;
  public join_eui!: string;
  public dev_addr!: string;
  public received_at_utc!: Date;
  public battery!: number;
  public latitude!: number;
  public longitude!: number;
  public created_at_utc!: Date;
  public updated_at_utc!: Date;
}

LpTtnEndDeviceUplinks.init(
  {
    lp_ttn_end_device_uplinks_id: {
      type: DataTypes.UUID,
      defaultValue: DataTypes.UUIDV4,
      primaryKey: true,
      allowNull: false,
    },
    device_id: {
      type: DataTypes.STRING,
      allowNull: false,
    },
    application_ids: {
      type: DataTypes.STRING,
      allowNull: true,
    },
    dev_eui: {
      type: DataTypes.STRING,
      allowNull: true,
    },
    join_eui: {
      type: DataTypes.STRING,
      allowNull: true,
    },
    dev_addr: {
      type: DataTypes.STRING,
      allowNull: true,
    },
    received_at_utc: {
      type: DataTypes.DATE,
      allowNull: true,
    },
    battery: {
      type: DataTypes.NUMBER,
      allowNull: true,
    },
    latitude: {
      type: DataTypes.NUMBER,
      allowNull: true,
    },
    longitude: {
      type: DataTypes.NUMBER,
      allowNull: true,
    },
    created_at_utc: {
      type: DataTypes.DATE,
      defaultValue: DataTypes.NOW,
      allowNull: false,
    },
    updated_at_utc: {
      type: DataTypes.DATE,
      defaultValue: DataTypes.NOW,
      allowNull: false,
    },
  },
  {
    sequelize,
    modelName: "LpTtnEndDeviceUplinks",
    tableName: "lp_ttn_end_device_uplinks",
    timestamps: false,
  }
);
